Target version: 3.3.6   

Description

By switching from and to, it is possible to create the same relates relation twice. Within the Redmine UI, those relations look like

duplicates.

For all other relationship types it's not allowed to create duplicates, so I assume that this is a bug. Attached you may find a proposed

fix. It adds a validation to make sure, that reverse relations are detected. It also orders the from and to IDs to ensure, that even

during concurrent access, the duplicates are detected on DB level.

Associated revisions

Revision 17054 - 2017-11-29 23:22 - Go MAEDA

Disallow creating inverse relates issue relations (#27663).

Patch by Gregor Schmidt.

Revision 17055 - 2017-11-30 01:02 - Go MAEDA

Reverted r17054 (#27663).

The change breaks test/functional/issue_relations_controller_test.rb.

Revision 17056 - 2017-12-06 10:01 - Go MAEDA

Disallow creating inverse relates issue relations (#27663).

Patch by Gregor Schmidt.

Revision 17057 - 2017-12-06 14:23 - Go MAEDA

Merged r17056 to 3.4-stable (#27663).

Revision 17058 - 2017-12-06 14:24 - Go MAEDA

Merged r17056 to 3.3-stable (#27663).

History

#1 - 2017-11-28 11:03 - Go MAEDA

- File duplicated-related-issue@2x.png added

- Target version set to Candidate for next minor release

I confirmed the problem.

 

sqlite> select * from issue_relations where issue_from_id in (42, 43);

id          issue_from_id  issue_to_id  relation_type  delay

----------  -------------  -----------  -------------  ----------

5           42             43           relates

4           43             42           relates
#2 - 2017-11-28 11:27 - Go MAEDA

- Target version changed from Candidate for next minor release to 3.3.6

LGTM. Setting target version to 3.3.6.

#3 - 2017-11-29 23:23 - Go MAEDA

- Status changed from New to Resolved

- Assignee set to Go MAEDA

#4 - 2017-11-30 01:07 - Go MAEDA

- Status changed from Resolved to New

- Assignee deleted (Go MAEDA)

The patch breaks a test.

$ bin/rails test test/functional/issue_relations_controller_test.rb

Run options: --seed 33551

# Running:

...F

Failure:

IssueRelationsControllerTest#test_create_xhr [/Users/maeda/redmines/redmine-trunk/test/functional/issue_relati

ons_controller_test.rb:85]:

Expected: 3

  Actual: 1

bin/rails test test/functional/issue_relations_controller_test.rb:70

........

Finished in 4.495535s, 2.6693 runs/s, 6.6733 assertions/s.

12 runs, 30 assertions, 1 failures, 0 errors, 0 skips

#5 - 2017-11-30 01:33 - Go MAEDA

Fix for the test failure described in #27663#note-4.

issue_from_id is always smaller than issue_to_id after applying the patch.

Index: test/functional/issue_relations_controller_test.rb

===================================================================

--- test/functional/issue_relations_controller_test.rb    (revision 17054)

+++ test/functional/issue_relations_controller_test.rb    (working copy)

@@ -82,8 +82,8 @@

       assert_equal 'text/javascript', response.content_type

     end

     relation = IssueRelation.order('id DESC').first

-    assert_equal 3, relation.issue_from_id

-    assert_equal 1, relation.issue_to_id

+    assert_equal 1, relation.issue_from_id

+    assert_equal 3, relation.issue_to_id

     assert_include 'Bug #1', response.body

   end

#6 - 2017-12-06 14:28 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed in the trunk and merged to stable branches. Thank you.

#7 - 2017-12-06 14:32 - Gregor Schmidt

Thanks a lot.

I am very sorry for breaking the test suite. I hope this did not cause too much trouble. I'll make sure to run the whole test suite next time.
0001-Disallow-creating-inverse-relates-issue-relations.patch 3 KB 2017-11-28 Gregor Schmidt

duplicated-related-issue@2x.png 13 KB 2017-11-28 Go MAEDA

Powered by TCPDF (www.tcpdf.org)

2024-03-13 3/3

http://www.tcpdf.org

